if (!Array.prototype.indexOf) {
    Array.prototype.indexOf = function (searchElement /*, fromIndex */ ) {
        "use strict";
        if (this == null) {
            throw new TypeError();
        }
        var t = Object(this);
        var len = t.length >>> 0;
        if (len === 0) {
            return -1;
        }
        var n = 0;
        if (arguments.length > 1) {
            n = Number(arguments[1]);
            if (n != n) { // shortcut for verifying if it's NaN
                n = 0;
            } else if (n != 0 && n != Infinity && n != -Infinity) {
                n = (n > 0 || -1) * Math.floor(Math.abs(n));
            }
        }
        if (n >= len) {
            return -1;
        }
        var k = n >= 0 ? n : Math.max(len - Math.abs(n), 0);
        for (; k < len; k++) {
            if (k in t && t[k] === searchElement) {
                return k;
            }
        }
        return -1;
    }
}

var sp = (function(){
	var that = {}, classesForTracking = [' order', ' promotion', ' featured', ' adbanner'];
	
	function init(){
		that.load();
	}
	
	//returns all anchors and areas on document as an array
	function getAllAnchorAndAreaObjects(){
		if (document.getElementsByTagName) {
			var links = document.getElementsByTagName("a");
			var areas = document.getElementsByTagName("area");  
			var links_temp = new Array();
			var count;

			for(var i=0; i<areas.length; i++){
				links_temp[i] = areas[i];  
			}

			count = links_temp.length;
			for(var i=0; i<links.length; i++){
				links_temp[count] = links[i];
				count = count+1;
			}

			return links_temp;
		}
		return false;
	}
	
	/*
	Deprecated
	*/
	function isTrackingClass(linkRelAttribute, linkClassAttribute)
	{
		if(linkRelAttribute) 
		{    
		if (linkRelAttribute.indexOf("samewindow") != -1) 
		{
			 for(var i=0; i<classesForTracking.length; i++)
			 {
				 var trackingClass = classesForTracking[i];
				 if(linkClassAttribute.indexOf(trackingClass) != -1)
				 {
					   return true;
				 }
			 }         
		}
		} 
		return false;     
	}

	/*
	Deprecated
	*/
	function stopDefault(evt, link)
	{
	   if(!e) 
		 var e = (window.event) ? window.event : evt;

		e.cancelBubble = true;
		e.returnValue = false;

		if (e.stopPropagation) {
			e.stopPropagation();
			e.preventDefault();
		}
	}	

	/*
	Deprecated
	*/
	function showPlayer(evt, link) {
		if(link == null)
			link = this;
		pURL = link.getAttribute("href");
		displayWindow(pURL,"Player",620,460,"directories=0,location=0,menubar=0,resizable=0,scrollbars=0,status=0,titlebar=0,toolbar=0");
		return false;
	}

	/*
	Deprecated
	*/
	function displayWindow(theURL,winName,width,height,features) { //v3.1
		var window_width = width;
		var window_height = height;
		var newfeatures= features;
		var window_top = (screen.height-window_height)/2;
		var window_left = (screen.width-window_width)/2;
		newWindow=window.open(''+ theURL + '',''+ winName + '','width=' + window_width + ',height=' + window_height + ',top=' + window_top + ',left=' + window_left + ','+ newfeatures + '');
		newWindow.focus();
	}
	
	/*
	Deprecated
	*/
	function sameWindow(link)
	{
		if(link == null)
		  link = this;
		var winURL = link.getAttribute("href");
		setTimeout(function () {window.location.href=winURL;},100);
	}

	/*
	Deprecated
	*/
	function openLinkInSameWindow(link)
	{
		var linkClassAttribute = link.className;
		var linkRelAttribute = link.getAttribute("rel"); 
		if( linkRelAttribute != null && linkClassAttribute != null )
		{
			if (linkRelAttribute.indexOf("samewindow") != -1 && (isTrackingClass(linkRelAttribute, linkClassAttribute)))
				 {
					   sameWindow(link);
				 }
		}
	}
	
	//return tracking id that precedes the given tracking name
	function getTrackingIdFromClassName(className, trackingName){
		var parts = className.split(" ");
		var index = parts.indexOf(trackingName);
		var trackingIdIndex = index-1;

		if(index === -1){
			return 'error_trackingname_notfound'; 	//tracking name not found in class name
		}

		if(parts <= 1){
			return 'error_insufficient_classnames'; //less than 1 class name 
		}

		if(!parts[trackingIdIndex]){
			return 'error_no_uniqueid';	//no tracking id preceeding tracking name
		}

		return parts[trackingIdIndex];
	}
	
	function getFeaturedOmnitureVars(evt, link)
	{
		if (link == null)
			  link = this;
			  
		var url = link.getAttribute("href");
		var uniqueId = getTrackingIdFromClassName(link.className, 'featured')
		if (that.omnitureExists())
		{
			sCode.trackFeaturedContentClick(url, uniqueId);  
		}
		openLinkInSameWindow(link);
	}

	function getPromotionOmnitureVars(evt, link)
	{
		if (link == null)
			  link = this;
			  
		var url = link.getAttribute("href");
		var uniqueId = getTrackingIdFromClassName(link.className, 'promotion')
		if (that.omnitureExists())
		{
			sCode.trackOutboundClick(url, uniqueId);  
		}
		openLinkInSameWindow(link);
	}

	function getOrderOmnitureVars(evt, link)
	{
		if (link == null)
			  link = this;
		
		var url = link.getAttribute("href");
		var uniqueId = getTrackingIdFromClassName(link.className, 'order')
		
		if (that.omnitureExists())
		{
			sCode.trackOutboundClickToBuy(url,uniqueId);
		}
		openLinkInSameWindow(link);
	}
	
	that = {
		addEvent: function( obj, type, fn ) {//John Resig's addEvent()
			if ( obj.attachEvent ) {
			obj['e'+type+fn] = fn;
			obj[type+fn] = function(){obj['e'+type+fn]( window.event );}
			obj.attachEvent( 'on'+type, obj[type+fn] );
			} else
			obj.addEventListener( type, fn, false );
		},	
		removeEvent: function( obj, type, fn ) {//John Resig's removeEvent()
			if ( obj.detachEvent ) {
			obj.detachEvent( 'on'+type, obj[type+fn] );
			obj[type+fn] = null;
			} else
			obj.removeEventListener( type, fn, false );
		},
		isPredefined: function(obj,str){//check to see if this is a predefined javascript object
			return Object.prototype.toString.call(obj) === '[object '+str+']';
		},
		appendSPEventsToElements: function(elements){
			if(elements){
				for (var i=0; i<elements.length; i++){	
					that.appendSPEvents(elements[i]);
				}
			}
			return false;
		},
		appendSPEvents: function(el){
			if(el){
				that.appendPopUpEvents(el);
				that.appendTrackingEvents(el);
			}
			return false;
		},
		omnitureExists: function(){
			if (s != null && (s.pageName.length != 0))
				return true;
			else return false;
		},
		appendPopUpEvents: function(link){
			var linkClassAttribute = link.className;
			var linkRelAttribute = link.getAttribute("rel");
			 
			if(linkRelAttribute)
			{
				var parsedLinkAttribute = linkRelAttribute.split(" ");
				for(var j=0; j<parsedLinkAttribute.length; j++)
				{
					if ( parsedLinkAttribute[j] == "player") 
					{
						that.addEvent(link,'click',showPlayer);
					 }
					 else
					 {
						if (parsedLinkAttribute[j] == "external") 
						{
							link.setAttribute('target','_blank');
						}
						else  
						{
							if (parsedLinkAttribute[j] == "forgot_password") 
						   {
							   that.addEvent(link,'click', function() 
							   { 
								  displayWindow("http://www.sonypictures.com/spn/spn_forgot_password_screen.php","forgot_password",395,170,"directories=0,location=0,menubar=0,resizable=0,scrollbars=0,status=0,titlebar=0,toolbar=0");
								  return false;
							   })
							}
						}
					 }
				 }
			 }       
		},
		appendTrackingEvents: function(link){
			var linkClassAttribute = link.className;
			var linkRelAttribute = link.getAttribute("rel");
			
			if(linkRelAttribute) 
			{    
				if (linkRelAttribute.indexOf("samewindow") != -1) 
				  {
					 if(isTrackingClass(linkRelAttribute, linkClassAttribute))
					 {
						   that.addEvent(link,'click',stopDefault);
					 }
				  }
			}
			
			if(linkClassAttribute) 
			{
				var parsedClassAttribute = linkClassAttribute.split(" ");
				for(var j=0; j<parsedClassAttribute.length; j++)
				{
					if ( parsedClassAttribute[j] == "promotion")
					{ 
						that.addEvent(link,'click', getPromotionOmnitureVars);
					}

					if ( parsedClassAttribute[j] == "order")
					{
						that.addEvent(link,'click', getOrderOmnitureVars);
					}
					
					if ( parsedClassAttribute[j] == "featured")
					{
						that.addEvent(link,'click', getFeaturedOmnitureVars);
					}
				}       
			}      
		},
		load: function(){
			that.addEvent(window, 'load', function(){
				that.appendSPEventsToElements(getAllAnchorAndAreaObjects());		
				if(typeof spSearchForm == 'function'){
					var search = new spSearchForm();
				}
			})
		}
	}
	
	init();
	
	return that;
}());